<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:ui="http://java.sun.com/jsf/facelets"
				xmlns:f="http://java.sun.com/jsf/core"
                xmlns:p="http://primefaces.org/ui"
                template="/WEB-INF/templates/mainWithMenu.xhtml">

    <ui:define name="title">
        PEDIDO VENTA
    </ui:define>

    <ui:define name="body-title">
        <h:outputText value="PEDIDO VENTA"/>
    </ui:define>

    <ui:define name="body">		
		<h:panelGrid columns="2" cellpadding="0" id="panel0" columnClasses="columnWidth75 centerAlign, columnWidth25 leftAlign topAlign topTAlign" width="100%">
			<h:panelGrid columns="1" cellpadding="0" id="panelL" width="100%" columnClasses="leftAlign">

				<h:form id="form1" rendered="true">					
					<h:panelGrid columns="1" cellpadding="0" id="panel1" width="100%" columnClasses="leftAlign">

						<p:outputLabel for="almacen" value="ALMACÉN :" />

						<p:selectOneMenu id="almacen" value="#{pedidoVentaMB.tipoAlmacen}" style="width:125px" disabled="#{pedidoVentaMB.pedidoFinalizado}">							
							<f:selectItems  value="#{pedidoVentaMB.tipoAlmacenList}"/>
							<p:ajax listener="#{pedidoVentaMB.onTipoAlmacenChange}" process="@all" update=":form1,:form2,:form2a,:form3,:form4"/>
						</p:selectOneMenu>

						<p:outputLabel for="cadenaBusqueda" value="BUSCAR POR: NOMBRE,PRESENTACIÓN,LINEA O MARCA :" rendered="true"/>

						<h:panelGroup rendered="true">
							<p:inputText id="cadenaBusqueda" value="#{pedidoVentaMB.cadenaBusqueda}" size="50" maxlength="128" valueChangeListener="#{pedidoVentaMB.cadenaBusquedaChanged}"
										 title="BUSCAR PRODUCTOS CONTENGAN EL TEXTO" disabled="#{pedidoVentaMB.pedidoFinalizado}">
								<p:ajax event="change" listener="#{pedidoVentaMB.buscarXCadena()}" process=":form1" update="panel1,:form2,:form2a"/>
							</p:inputText>						

							<p:commandButton icon="ui-icon-search" update=":form2:panel2" actionListener="#{pedidoVentaMB.buscarXBoton}" rendered="false" disabled="#{pedidoVentaMB.pedidoFinalizado}"/>

							<p:selectBooleanButton   id="conservarBusqueda" value="#{pedidoVentaMB.conservarBusqueda}" onLabel="CONSERVAR RESULT." offLabel="LIMPIAR RESULT." 
													 onIcon="ui-icon-check" offIcon="ui-icon-close" disabled="#{pedidoVentaMB.pedidoFinalizado}">
								<p:ajax process=":form1" update=":form1" listener="#{pedidoVentaMB.conservarBusquedaChanged}" />
							</p:selectBooleanButton>

						</h:panelGroup>
					</h:panelGrid>
				</h:form>

				<h:form id="form2" rendered="true">
					<p:growl id="growl" showDetail="true" sticky="false" autoUpdate="true"  /> 

					<h:panelGrid columns="1" cellpadding="0" id="panel2" columnClasses="leftAlign" width="100%">

						<p:outputLabel value="CANTIDAD x PRODUCTO :" rendered="true"/>

						<h:panelGroup rendered="true">
							<p:inputText value="#{pedidoVentaMB.cantidadAgregarBusqueda}" size="3" maxlength="5" rendered="false" disabled="#{pedidoVentaMB.pedidoFinalizado}">
								<f:convertNumber integerOnly="true"/>
							</p:inputText>

							<p:spinner id="cantidadAgregarBusquedaSpinner" value="#{pedidoVentaMB.cantidadAgregarBusqueda}" min="1" max="9999" size="1" disabled="#{pedidoVentaMB.pedidoFinalizado}"/>

							<p:outputLabel value=" x " />
							<p:selectOneMenu id="resultadoBusqueda" value="#{pedidoVentaMB.resultadoBusquedaSelected}" disabled="#{pedidoVentaMB.pedidoFinalizado}">							
								<f:selectItems  value="#{pedidoVentaMB.resultadoBusqueda}"/>
								<p:ajax process=":form2:panel2" listener="#{pedidoVentaMB.onResultadoBusquedaChange}" update=":form2:panel2" />							
							</p:selectOneMenu>

							<p:commandButton id="masInfo" icon="ui-icon-comment" type="button" process=":form2" rendered="#{not empty pedidoVentaMB.resultadoBusqueda}"
											 disabled="#{pedidoVentaMB.pedidoFinalizado}"/>

							<p:overlayPanel id="masInfoPanel" for="masInfo" hideEffect="fade" dismissable="true" showCloseIcon="false">
								<h:panelGrid columns="2" cellpadding="0" width="300" columnClasses="columnWidth40 rightAlign, columnWidth60 leftAlign">
									<h:outputText value="LINEA :" />
									<h:outputText value="#{pedidoVentaMB.resultadoBusquedaSI.productoLinea}" class="bold_text"/>

									<h:outputText value="MARCA :" />
									<h:outputText value="#{pedidoVentaMB.resultadoBusquedaSI.productoMarca}" class="bold_text" />

									<h:outputText value="CANTIDAD ACTUAL :" />
									<h:outputText value="#{pedidoVentaMB.resultadoBusquedaSI.cantidad}" class="bold_text" />

									<h:outputText value="CONTENIDO :" />
									<h:outputText value="#{pedidoVentaMB.resultadoBusquedaSI.productoContenido} #{pedidoVentaMB.resultadoBusquedaSI.productoUnidadMedida}" class="bold_text" />

									<h:outputText value="PRECIO :" />
									<h:outputText value="#{pedidoVentaMB.resultadoBusquedaSI.precioVenta}" class="bold_text" >
										<f:convertNumber maxFractionDigits="2" pattern="$ ###,###,##0.00" locale="es_MX"/>
									</h:outputText>
								</h:panelGrid>
							</p:overlayPanel>
							<p:spacer width="10"/>
							<p:commandButton value="+"  actionListener="#{pedidoVentaMB.agregarSeleccionadoDeBusqueda}" id="xx1" disabled="#{pedidoVentaMB.pedidoFinalizado}"
											 process=":form2" update=":form1,:form2,growl,:form3,:form4:panel4_3"  
											 rendered="#{not empty pedidoVentaMB.resultadoBusqueda}"
											 oncomplete="updateComponentsOnWindowResize();"/>
						</h:panelGroup>
					</h:panelGrid>
				</h:form>
				<h:form id="form2a" rendered="true">

					<h:panelGrid columns="1" cellpadding="0" id="panel2a" columnClasses="leftAlign" width="100%">
						<p:outputLabel value="CANTIDAD x CODIGO :" />

						<h:panelGroup>
							<p:inputText value="#{pedidoVentaMB.cantidadAgregarCodigo}" size="3" maxlength="5" rendered="false" disabled="#{pedidoVentaMB.pedidoFinalizado}">
								<f:convertNumber integerOnly="true"/>
							</p:inputText>

							<p:spinner id="cantidadAgregarCodigoSpinner" value="#{pedidoVentaMB.cantidadAgregarCodigo}" min="1" max="9999" size="1" disabled="#{pedidoVentaMB.pedidoFinalizado}"/>

							<p:outputLabel value=" x " />
							<p:inputText value="#{pedidoVentaMB.codigo}" size="15" maxlength="15" valueChangeListener="#{pedidoVentaMB.codigoChanged}"
										 title="BUSCAR PRODUCTOS CONTENGAN EL TEXTO" disabled="#{pedidoVentaMB.pedidoFinalizado}">
								<p:ajax  event="change" listener="#{pedidoVentaMB.buscarXCodigo}" 
										 process=":form2a" update=":form1:panel1,:form2a:panel2a,:form3,:form4:panel4_3"
										 oncomplete="updateComponentsOnWindowResize();"/>
							</p:inputText>						

						</h:panelGroup>						

					</h:panelGrid>
				</h:form>

				<h:form id="form3" rendered="true">

					<h:panelGrid columns="1" cellpadding="0" id="panel3" columnClasses="leftAlign" width="100%" >						
						<p:dataTable  var="pvd" value="#{pedidoVentaMB.entityList}"
									  id="pvdTable" widgetVar="wv_pvdTable" emptyMessage="-- SIN ELEMENTOS --" 
									  scrollable="true" draggableRows="true"
									  editable="true" editMode="cell" 
									  scrollHeight="200" >
							<p:ajax event="rowReorder" listener="#{pedidoVentaMB.onRowReorder}" update=":form3:panel3" />
							<f:facet name="header">
								OPCIONES :
								<p:commandButton value="VER + COLUMNAS" actionListener="#{pedidoVentaMB.expandirTabla}" process=":form3" update=":form3:panel3" rendered="#{!pedidoVentaMB.tablaExpandida}" oncomplete="updateComponentsOnWindowResize();"/>
								<p:commandButton value="VER - COLUMNAS" actionListener="#{pedidoVentaMB.contraerTabla}" process=":form3" update=":form3:panel3" rendered="#{pedidoVentaMB.tablaExpandida}"  oncomplete="updateComponentsOnWindowResize();"/>
							</f:facet>

							<p:column headerText="." width="5%">
								<p:commandButton icon="ui-icon-trash" actionListener="#{pedidoVentaMB.deleteRow(pvd.rowId)}" 
												 title="rowId=#{pvd.rowId}" process=":form3" update=":form3,:form4:panel4_3"
												 oncomplete="updateComponentsOnWindowResize();" disabled="#{pedidoVentaMB.pedidoFinalizado}">
									<p:confirm header="ELIMINAR" message="¿ SEGURO QUE QUIERE ELIMINAR ?" icon="ui-icon-alert" />
								</p:commandButton>
							</p:column>

							<p:column headerText="#" width="5%">								
								 <p:cellEditor>
									<f:facet name="output"><h:outputText value="#{pvd.cantidad}" /></f:facet>
									<f:facet name="input">
										<p:spinner value="#{pvd.cantidad}" min="1" max="9999" size="1" valueChangeListener="#{pedidoVentaMB.cantidadDetalleChanged}"  >
											<p:ajax process="@this" event="change" listener="#{pedidoVentaMB.cantidadDetalleCambio(pvd.rowId)}" update=":form4:panel4_3a"/>
										</p:spinner>
									</f:facet>
								</p:cellEditor>
							</p:column>

							<p:column headerText="ALM." width="5%" >
								<h:outputText value="1RA" rendered="#{pvd.apTipoAlmacen eq 1}" class="centerAlignColumn"/>
								<h:outputText value="OPO" rendered="#{pvd.apTipoAlmacen eq 2}" class="centerAlignColumn"/>
								<h:outputText value="REG" rendered="#{pvd.apTipoAlmacen eq 3}" class="centerAlignColumn"/>
							</p:column>

							<p:column headerText="CODIGO" width="15%">
								<h:outputText value="#{pvd.productoCodigoBarras}" />
							</p:column>

							<p:column headerText="LINEA" rendered="#{pedidoVentaMB.tablaExpandida}">
								<h:outputText value="#{pvd.productoLinea}" />
							</p:column>

							<p:column headerText="MARCA" rendered="#{pedidoVentaMB.tablaExpandida}">
								<h:outputText value="#{pvd.productoMarca}" />
							</p:column>

							<p:column headerText="NOMBRE" rendered="#{pedidoVentaMB.tablaExpandida}">
								<h:outputText value="#{pvd.productoNombre}" />
							</p:column>

							<p:column headerText="PRESN." rendered="#{pedidoVentaMB.tablaExpandida}">
								<h:outputText value="#{pvd.productoPresentacion}" />
							</p:column>

							<p:column headerText="CONT." rendered="#{pedidoVentaMB.tablaExpandida}">
								<h:outputText value="#{pvd.productoContenido} #{pvd.productoUnidadMedida}" />
							</p:column>

							<p:column headerText="PRECIO" width="10%">
								<h:outputText value="#{pvd.precioVenta}" title="#{pedidoVentaMB.getImporteDesglosado(pvd.precioVenta)}" class="rightAlignColumn">
									<f:convertNumber maxFractionDigits="2" pattern="$ ###,###,##0.00" locale="es_MX"/>
								</h:outputText>
							</p:column>

							<p:column headerText="IMPORTE" width="10%">
								<h:outputText value="#{pvd.cantidad * pvd.precioVenta}" title="#{pedidoVentaMB.getImporteDesglosado(pvd.cantidad * pvd.precioVenta)}" class="rightAlignColumn">
									<f:convertNumber maxFractionDigits="2" pattern="$ ###,###,##0.00" locale="es_MX"/>
								</h:outputText>
							</p:column>

							<f:facet name="footer">
								<h:outputText value="ELEMENTOS : #{pedidoVentaMB.sizeList}" rendered="true"/>
							</f:facet>
						</p:dataTable>

					</h:panelGrid>
				</h:form>

			</h:panelGrid>

			<h:panelGrid columns="1" cellpadding="0" columnClasses="centerAlign bottomAlign"  width="100%">
				<h:form id="form4">
					
					<p:dialog header="SELECCIONAR CLIENTE" widgetVar="dlgSeleccionarCliente" modal="true" height="250" width="500" id="dlgClientes">

						<p:dataTable var="cliente" value="#{pedidoVentaMB.clientes}" scrollHeight="200" >

							<p:column style="width:32px;text-align: center">
								<p:commandButton	update=":form4:panel4_1,:form4:dlgClientes,:form4:panel4_3" 
													oncomplete="PF('dlgSeleccionarCliente').hide();" icon="ui-icon-check" title="SELECCIONAR"
													actionListener="#{pedidoVentaMB.seleccionaCliente(cliente.id)}">

								</p:commandButton>
							</p:column>

							<p:column headerText="RAZÓN SOCIAL :">
								<h:outputText value="#{cliente.razonSocial}" />
							</p:column>

							<p:column headerText="NOMBRE ESTAB. :">
								<h:outputText value="#{cliente.nombreEstablecimiento}" />
							</p:column>

							<p:column headerText="R.F.C. :">
								<h:outputText value="#{cliente.rfc}" />
							</p:column>

							<p:column headerText="TELEFONOS :">
								<h:outputText value="#{cliente.telefonos}" />
							</p:column>
						</p:dataTable>
					</p:dialog> 

					<h:panelGrid columns="1" id="panel4_1" cellpadding="0" columnClasses="leftAlign" width="100%">

						<p:outputLabel value="CLIENTE ( RAZ.SOC. / NOM.EST.):" />

						<h:panelGrid width="100%" columns="2" columnClasses="columnWidth90 leftAlign, columnWidth10 rightAlign">

							<h:panelGrid width="100%" columns="1" rendered="#{not empty pedidoVentaMB.clienteSeleccionado}"  cellpadding="0" cellspacing="0">

								<h:outputText value="#{pedidoVentaMB.clienteSeleccionado.razonSocial}/" 
											  style="font-size: 60%; color: #2e6e9e;" />
								<h:outputText value="#{pedidoVentaMB.clienteSeleccionado.nombreEstablecimiento}" 
											  style="font-size: 60%; color: #2e6e9e;" />

							</h:panelGrid>

							<h:outputText id="cteSeleccNull" value="--SELECCIONE--" 
										  style="font-size: 80%; color: #2e6e9e;" rendered="#{empty pedidoVentaMB.clienteSeleccionado}"/>

							<p:commandButton icon="ui-icon-triangle-1-s" type="button" onclick="PF('dlgSeleccionarCliente').show();" disabled="#{pedidoVentaMB.pedidoFinalizado}"/>

						</h:panelGrid>
					</h:panelGrid>
					<h:panelGrid columns="1" id="panel4_2" cellpadding="0" columnClasses="leftAlign" width="100%">
						<p:outputLabel value="MÉTODO DE PAGO :" />

						<p:selectOneMenu id="metodoDePago" value="#{pedidoVentaMB.pedidoVenta.metodoDePagoId}" disabled="#{pedidoVentaMB.pedidoFinalizado}">
							<f:selectItems  value="#{pedidoVentaMB.metodoDePagoList}"/>
							<p:ajax listener="#{pedidoVentaMB.onMetodoDePagoListChange}" process=":form4:panel4_2" update=":form4:panel4_2,:form4:panel4_3"/>
						</p:selectOneMenu>

						<p:outputLabel value="FORMA DE PAGO :" />

						<p:selectOneMenu id="formaDePago" value="#{pedidoVentaMB.pedidoVenta.formaDePagoId}" disabled="#{pedidoVentaMB.pedidoFinalizado}">							
							<f:selectItems  value="#{pedidoVentaMB.formaDePagoList}"/>
							<p:ajax listener="#{pedidoVentaMB.onFormaDePagoListChange}" process=":form4:panel4_2" update=":form4:panel4_2,:form4:panel4_3"/>
						</p:selectOneMenu>

						<p:outputLabel value="DESCUENTO EXTRA :" />

						<p:selectOneMenu id="descuentoEspecial" value="#{pedidoVentaMB.pedidoVenta.porcentajeDescuentoExtra}" disabled="#{pedidoVentaMB.pedidoFinalizado}">							
							<f:selectItems  value="#{pedidoVentaMB.descuentoEspacialList}"/>
							<p:ajax listener="#{pedidoVentaMB.onDescuentoEspecialListChange}" process=":form4:panel4_2" update=":form4:panel4_2,:form4:panel4_3"/>
						</p:selectOneMenu>

						<p:outputLabel value="COMENTARIOS :" />

						<h:inputTextarea id="comentarios" value="#{pedidoVentaMB.pedidoVenta.comentarios}" cols="30" rows="2"
										 title="COMENTARIOS ACERCA DEL PEDIDO" disabled="#{pedidoVentaMB.pedidoFinalizado}">
							<p:ajax		 event="blur" listener="#{pedidoVentaMB.onComentariosChange}" 
									  process=":form4:panel4_2" update=":form4:panel4_2,:form4:panel4_3"/>
						</h:inputTextarea>
						
						<p:outputLabel value="CONDICIONES :" />

						<h:inputTextarea id="condiciones" value="#{pedidoVentaMB.pedidoVenta.condicionesDePago}" cols="30" rows="2"
										 title="CONDICIONES DEL PEDIDO" disabled="#{pedidoVentaMB.pedidoFinalizado}">
							<p:ajax		 event="blur" listener="#{pedidoVentaMB.onCondicionesChange}" 
										 process=":form4:panel4_2" update=":form4:panel4_2,:form4:panel4_3"/>
						</h:inputTextarea>
					</h:panelGrid>
					
					<h:panelGrid columns="1" id="panel4_3" cellpadding="0" columnClasses="centerAlign" width="100%">
						<p:spacer width="10"/>
						<h:panelGrid id="panel4_3a" columns="2" cellpadding="0" columnClasses="columnWidth60 rightAlign, columnWidth40 rightAlign" width="100%">
							<h:outputText value="SUBTOTAL :" />
							<h:outputText value="#{pedidoVentaMB.pedidoVentaFooter.subTotalNoGrabado}">
								<f:convertNumber maxFractionDigits="2" pattern="$ ###,###,##0.00" locale="es_MX"/>
							</h:outputText>

							<h:outputText value="I.V.A. :" />
							<h:outputText value="#{pedidoVentaMB.pedidoVentaFooter.importeIVA}">
								<f:convertNumber maxFractionDigits="2" pattern="$ ###,###,##0.00" locale="es_MX"/>
							</h:outputText>

							<h:outputText value="- DESCUENTO :" />
							<h:outputText value="#{pedidoVentaMB.pedidoVentaFooter.importeDescuentoAplicado}" 
										  title="- ( #{pedidoVentaMB.pedidoVentaFooter.descuentoCalculado}% + #{pedidoVentaMB.pedidoVentaFooter.descuentoExtra}% = #{pedidoVentaMB.pedidoVentaFooter.descuentoAplicado}% )">
								<f:convertNumber maxFractionDigits="2" pattern="$ -###,###,##0.00" locale="es_MX"/>
							</h:outputText>

							<h:outputText value="T O T A L :" styleClass="bold_text"/>
							<h:outputText value="#{pedidoVentaMB.pedidoVentaFooter.total}" styleClass="bold_text">
								<f:convertNumber maxFractionDigits="2" pattern="$ ###,###,##0.00" locale="es_MX"/>
							</h:outputText>
						</h:panelGrid>
						<p:spacer width="10" rendered="#{not pedidoVentaMB.pedidoFinalizado}"/>
						<h:panelGrid columns="2" rendered="#{not pedidoVentaMB.pedidoFinalizado}" columnClasses="columnWidth50 centerAlign, columnWidth50 centerAlign" width="100%">
							<p:commandButton value="CANCELAR" actionListener="#{pedidoVentaMB.cancelar}" process="@all" rendered="#{not pedidoVentaMB.pedidoFinalizado}" icon="ui-icon-cancel"
											 update=":form1,:form2,:form3,:form4" oncomplete="updateComponentsOnWindowResize();">
								<p:confirm header="CANCELAR" message="¿ SEGURO QUE QUIERE CANCELAR ?" icon="ui-icon-alert" />
							</p:commandButton>						

							<p:commandButton value="CREAR PEDIDO"  actionListener="#{pedidoVentaMB.guardar}" disabled="#{not pedidoVentaMB.crearPedido}" icon="ui-icon-play"
											 process="@all" update=":form1,:form2,:form3,:form4" oncomplete="updateComponentsOnWindowResize();">
								<p:confirm header="CREAR PEDIDO" message="¿ SEGURO TERMINÓ Y QUIERE CREAR EL PEDIDO ?" icon="ui-icon-alert" />
							</p:commandButton>
						</h:panelGrid>

						<p:spacer width="10" height="10" />

						<h:outputText    value="PEDIDO ID : ##{pedidoVentaMB.pedidoVenta.id}" rendered="#{not empty pedidoVentaMB.pedidoVenta and pedidoVentaMB.pedidoFinalizado}"/>

						<p:spacer width="10" height="10" />

						<p:commandButton value="PEDIDO FINALIZADO, CERRAR"  actionListener="#{pedidoVentaMB.cerrar}" rendered="#{pedidoVentaMB.pedidoFinalizado}" 
										 process="@all" update=":form1,:form2,:form3,:form4" oncomplete="updateComponentsOnWindowResize();"/>

						<p:confirmDialog global="true" showEffect="bounce" hideEffect="explode" styleClass="centerAlign">
							<h:panelGrid columns="2" columnClasses="columnWidth50 centerAlign, columnWidth50 centerAlign"  width="100%">
								<p:commandButton value="SI, OK"    type="button" styleClass="ui-confirmdialog-yes" icon="ui-icon-check" />
								<p:commandButton value="NO, NUNCA" type="button" styleClass="ui-confirmdialog-no" icon="ui-icon-close" />
							</h:panelGrid>
								
						</p:confirmDialog>

						<div id="debugDivOutput">						
						</div>
					</h:panelGrid>

				</h:form>
			</h:panelGrid>


		</h:panelGrid>
		<script>
			var counterResized = 0;
			function updateComponentsOnWindowResize() {

				//var txt="";
				//txt+="["+counterResized+"]Resized:(" + $(window).width() + " x  " + $(window).height() +"), table height:"+$(".ui-datatable-scrollable-body").height();
				//$("#debugDivOutput").html(txt);
				setDataTableHeight();
				counterResized++;
			}

			function setDataTableHeight() {
				var winHeight = $(window).height();

				var scrollHeight = winHeight - 450;

				var scrollBody = $(".ui-datatable-scrollable-body");
				scrollBody.height(scrollHeight);

			}

			$(document).ready(function() {

				$(window).resize(function() {
					updateComponentsOnWindowResize();
				});

				updateComponentsOnWindowResize();

			});
		</script>		

	</ui:define>

</ui:composition>
